/* int1_1.c
 *
 *
 */

#include "iodefine.h"
#include "typedefine.h"
#include "machine.h"

//#define USE_INT

#define	printf	((int (*)(const char *,...))0x00007c7c)

#define	SW6 	(PD.DR.BIT.B18)
#define	SW5 	(PD.DR.BIT.B17)
#define	SW4 	(PD.DR.BIT.B16)

#define	LED6	(PE.DR.BIT.B11)
#define	LED5	(PE.DR.BIT.B9)
#define	LED_ON	(0)
#define	LED_OFF	(1)


// -------------------------------------
// IRQ0(SW4)̊荞ݏ֐
#pragma interrupt INT_IRQ0
void INT_IRQ0()
{
	INTC.IRQSR.BIT.IRQ0F = 0;		// 荞ݗvNA

	if (INTC.IRQSR.BIT.IRQ0L == 1)
		// IRQ0[q = 1 ... SW4 Ă
		LED6 = LED_ON;
	else
		LED6 = LED_OFF;
}


// -------------------------------------

#ifdef USE_INT
// 荞݂gpƂ̃C֐
void main()
{
	PFC.PEIORL.BIT.B11 = 1;			// PE11(LED6)[qo̓[hɐݒ
	PFC.PDCRH1.BIT.PD16MD = 2;		// PD16(SW4)[qIRQ0͂ɐݒ
	INTC.IRQCR.BIT.IRQ0S = 3;		// オA̗GbW
	INTC.IPRA.BIT._IRQ0 = 8;		// 荞ݗD惌x = 8

	set_imask(7);					// }XNrbg = 7

	LED6 = LED_OFF;					// LED6

	while (1)
		;
}

#else
// 荞݂gpȂƂ̃C֐
void main()
{
	PFC.PEIORL.BIT.B11 = 1;			// PE11(LED6)[qo̓[hɐݒ

	while (1) {
		if (SW4 == 1)
			LED6 = LED_ON;
		else
			LED6 = LED_OFF;
	}
}
#endif